%define name roxen
%define version 2.0.66
%define release 1

Name: %{name} 
Summary: Roxen Challenger 2 is a powerfull and easy to adminstrate webserver. 
Version: %{version}
Release: %{release}
Source0: cvs:/pserver:anon@cvs.roxen.com/Roxen/2.0/Roxen_server_cvs-2000-07-07.tar.gz
Source1: roxen2-globals.template
Source2: roxen2-server.template
Source3: roxen-initscript
Source4: bg.gif
Source5: logo.gif
Source6: mandrake.gif
Source7: redhat.gif
Source8: index.html
# Source20: roxen-server-SSL.tar.gz
Group: System/Servers
URL: http://www.roxen.com/
BuildRoot: /var/tmp/%{name}-buildroot
Copyright: GPL
Packager: Wim Bonis <bonis@solution-service.de>
Prefix: /usr
AutoReqProv: no 
Provides: webserver
Requires: pike >= 7.0.71

%description
Roxen Challenger 2 is a webserver, based at the language Pike. It offers
full administration using a WWW-interface, SSL-support, adding/deleting/updating 
of internal modules without recompiling, shutdown/restart without superuser-
privileges, multiple administration-levels with different accounts, diagram
and graphic generators, XML- and WAP-support and many many many more
modules. Once you use it, you will love it.

As from roxen-2.0.65-1mdk the package has been split into two RPMs: 
  o pike	Contains the scripting language Pike
  o roxen	Contains Roxen Webserver, needs pike to run
  
You must install both RPMs to get Roxen Webserver working!

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -c roxen-%{version}
# %setup -T -D -a 20

%build
# Nothing to do here

%install
# As Roxen bases on Pike, there is no compilation needed. Just copy the files
# over and setup some symlinks'n'stuff...
mkdir -p $RPM_BUILD_ROOT/%{prefix}/%{name}
/bin/cp -pr server $RPM_BUILD_ROOT/%{prefix}/%{name}/

# Delete the CVS-subdirectories and pike-roxen to save place
find $RPM_BUILD_ROOT/%{prefix}/%{name} -type d -name CVS -print | xargs /bin/rm -rf
find $RPM_BUILD_ROOT/%{prefix}/%{name} -type d -name pike-roxen -print | xargs /bin/rm -rf 

# Define some directories
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/var/log/roxen
mkdir -p $RPM_BUILD_ROOT/etc/roxen
mkdir -p $RPM_BUILD_ROOT/home/roxen/html
mkdir -p $RPM_BUILD_ROOT/home/roxen/cgi-bin
mkdir -p $RPM_BUILD_ROOT/home/roxen/fcgi-bin
mkdir -p $RPM_BUILD_ROOT/home/roxen/randomtext

echo "To setup a configuration interface" > readme.txt
echo "==================================" >> readme.txt
echo "  o As Root start %{prefix}/roxen/server/create_configinterface" >> readme.txt
echo "  o Answer all questions (Login, Password, URL)" >> readme.txt
echo "  o Restart Roxen" >> readme.txt
echo "  o Use your favorite browser to the choosen URL" >> readme.txt

# Contains some GIFs for the default-index.html-welcome-page
mkdir -p $RPM_BUILD_ROOT/home/roxen/html/welcome

# Set up logging-directory
cd $RPM_BUILD_ROOT%{prefix}/%{name}
if [ -d logs ] ; then
	rmdir logs
fi
ln -sf /var/log/roxen logs
cd $RPM_BUILD_ROOT/etc/roxen
ln -sf /var/log/roxen logs

# Set up configuration-directory
cd $RPM_BUILD_ROOT%{prefix}/%{name}
if [ -d configurations ]; then
   mv -f $RPM_BUILD_ROOT%{prefix}/roxen/configurations \
	     $RPM_BUILD_ROOT/etc/roxen/configurations
fi
mkdir -p $RPM_BUILD_ROOT/etc/roxen/configurations
ln -s /etc/roxen/configurations configurations

# Setup needed pike-link
cd $RPM_BUILD_ROOT%{prefix}/%{name}
ln -s /usr/pike pike
cd server
ln -s /usr/pike pike

# Init.d-script
cp -f %{SOURCE3}     $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen
chown root:root      $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen
chmod u=rwx,g=rx,o=rx $RPM_BUILD_ROOT/etc/rc.d/init.d/roxen

# Install welcome-HTML-page including graphics
cp -f %{SOURCE4}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE5}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE6}	 $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE7}     $RPM_BUILD_ROOT/home/roxen/html/welcome/
cp -f %{SOURCE8}	 $RPM_BUILD_ROOT/home/roxen/html/
chown -R root:root   $RPM_BUILD_ROOT/home/roxen 
find $RPM_BUILD_ROOT/home/roxen -type d -exec chmod u=rwx,g=rx,o=rx {} \;
find $RPM_BUILD_ROOT/home/roxen -type f -exec chmod u=rw,g=r,o=r {} \;

# To include the templates :(
cp -f %{SOURCE1} $RPM_BUILD_ROOT/etc/roxen/
cp -f %{SOURCE2} $RPM_BUILD_ROOT/etc/roxen/

# Make the Roxen-Starter easier to find in ps
cd $RPM_BUILD_ROOT%{prefix}/roxen/server
ln start RunRoxen

# Standard operations taken from the spec-template
if [ -d $RPM_BUILD_ROOT/usr/man ]; then
  find $RPM_BUILD_ROOT/usr/man -type f -exec gzip {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/info ]; then
  find $RPM_BUILD_ROOT/usr/info -type f -exec gzip {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/X11R6/man ]; then
  find $RPM_BUILD_ROOT/usr/X11R6/man -type f -exec gzip {} \;
fi
if [ -d $RPM_BUILD_ROOT/usr/lib/perl5/man ]; then
  find $RPM_BUILD_ROOT/usr/lib/perl5/man -type f -exec gzip {} \;
fi

if [ -d $RPM_BUILD_ROOT/usr/bin ]; then
  find $RPM_BUILD_ROOT/usr/bin -type f -exec strip {} \;
fi

# Strip all binaries
if [ -d $RPM_BUILD_ROOT/%{prefix}/roxen/server/bin ]; then
  find $RPM_BUILD_ROOT/%{prefix}/roxen/server/bin -type f -exec strip {} \;
fi
if [ -d $RPM_BUILD_ROOT/%{prefix}/pike/*/bin ]; then
  find $RPM_BUILD_ROOT/%{prefix}/pike/*/bin -type f -exec strip {} \;
fi

# Correct #!/usr/local/bin/pike lines to get dependencies working :(
find $RPM_BUILD_ROOT -type f -exec /usr/bin/perl -p -i -e  \
      's/^\#\!\/usr\/local\/bin\/pike/\#\!\/usr\/bin\/pike/' {} \;

# Generate file-list for the RPM-builder
cd $RPM_BUILD_ROOT
# First, remove TAGS files, otherwise spec-helper will make troubles
find . -type f -name "TAGS" -exec /bin/rm -f '{}' \;

find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
	$RPM_BUILD_DIR/file.list.%{name}

find . -type f | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
       -e '/\/etc\//s|^|%config |' \
       -e '/\/config\//s|^|%config |' \
       >> $RPM_BUILD_DIR/file.list.%{name}

find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
	$RPM_BUILD_DIR/file.list.%{name}

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}

%files -f ../file.list.%{name}
%defattr(-,root,root,0755)
%doc readme.txt CHANGES GPL COPYING

%preun
if [ $1 -eq 0 ]; then	# We're running "rpm -e"
	if [ -x /etc/rc.d/init.d/roxen ]; then
		/etc/rc.d/init.d/roxen stop;
		chkconfig --del roxen;
	fi
	rm -f /etc/rc.d/init.d/roxen;
	rm -f /usr/roxen/pike
	rm -f /usr/roxen/server/pike
	rm -f /usr/roxen/server/bin/roxen
	rm -rf /var/log/roxen/*;
fi

%post
if [ $1 -eq 1 ]; then	# We're running "rpm -i"

	# Install templates
	# a) Global Variables. No hostname/domainname-dependencies
	cat /etc/roxen/roxen2-globals.template \
		| sed -e "s#%%PREFIX%%#${PREFIX}#g" > \
		/etc/roxen/configurations/Global_Variables
	# b) Generate a server with hostname
	cat /etc/roxen/roxen2-server.template    \
		| sed -e "s/%%FULLHOST%%/`hostname`.`domainname`/g" \
		      -e "s/%%SHORTNAME%%/`hostname`/g" \
		      -e "s/%%DOMAIN%%/`domainname`/g" > \
		/etc/roxen/configurations/`hostname`

    # Delete templates
    #	rm -f /etc/roxen/configurations/*.template \
    #		  /etc/roxen/_configinterface/settings/*.template

    # Add Roxen in according Runlevels
	chkconfig --add roxen
	chkconfig roxen on

    # We need a symlink to the pike-binary or Roxen will not start
    # * is the version-number (like 7.0.71). As only one Pike-RPM can be
    # installed, there is only one subdirectory (hopefully :)
	cd /usr/roxen/server/bin
	ln -s /usr/pike/*/bin/pike pike
	ln -s /usr/pike/*/bin/pike roxen

    # Create a Roxen user. Do not report any problems if it already
    # exists. This is redhat specific and should be handled more portable
	useradd -M -r -d /home/roxen -s /bin/bash -c "Roxen server" roxen 2> /dev/null || true

    # Change permissions so that the user that will run the roxen daemon
    # owns all database files.
	mkdir -p /%{prefix}/roxen/var/%{version}/precompiled /%{prefix}/roxen/var/cache/args /%{prefix}/roxen/info
	mkdir -p /%{prefix}/roxen/local/nfonts /%{prefix}/roxen/local/modules /%{prefix}/roxen/local/packages
	chown -R roxen:roxen /%{prefix}/roxen/var /%{prefix}/roxen/local /%{prefix}/roxen/info /etc/roxen /var/log/roxen /%{prefix}/roxen/server/config_interface

	echo "-----------------------------------"
	echo "/usr/doc/roxen-%{version}/readme.txt:"
	echo
	cat  /usr/doc/roxen-%{version}/readme.txt
	echo "-----------------------------------"

elif [ $1 -gt 1 ]; then	# We're running "rpm -U"
	/etc/rc.d/init.d/roxen status 2>&1 > /dev/null
	if [ $? -eq 0 ]; then
		/etc/rc.d/init.d/roxen restart
	fi
fi

%changelog
* Sun Jul 09 2000 Wim Bonis <bonis@solution-service.de>
- Roxen run under the user roxen
- Added symlink from pike to roxen
- Moved SSL into a different RPM (export restrictions)

* Fri Jul 07 2000 Oliver Schade <os@ls-la.net>
- 2.0.65-1mdk
- Splitted 2.0.65-6kiss / 2.0.50-1mdk into two RPMs (Pike & Roxen)
